#bygonebytes.co.uk (2021) - Aviemore
import machine, utime
import _thread
from esp8266_i2c_lcd import I2cLcd
from machine import I2C

#display i2c
DEFAULT_I2C_ADDR = 0x27
sda=machine.Pin(0)
scl=machine.Pin(1)
i2c=machine.I2C(0,sda=sda, scl=scl, freq=400000)
lcd = I2cLcd(i2c, DEFAULT_I2C_ADDR, 4, 20)
address = 0x68
register = 0x00
bus = I2C(1)

# define outputs
swa = machine.Pin(2, machine.Pin.OUT)
swb = machine.Pin(3, machine.Pin.OUT)
swc = machine.Pin(4, machine.Pin.OUT)
swd = machine.Pin(5, machine.Pin.OUT)
swe = machine.Pin(6, machine.Pin.OUT)
swf = machine.Pin(7, machine.Pin.OUT)
swg = machine.Pin(8, machine.Pin.OUT)
swh = machine.Pin(9, machine.Pin.OUT)
exts = machine.Pin(10, machine.Pin.OUT)

#set outputs high
def reset():
    swa.value(1)
    swb.value(1)
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    
reset()
exts.value(1)

#define inputs
up = machine.Pin(11, machine.Pin.IN, machine.Pin.PULL_UP)
down = machine.Pin(12, machine.Pin.IN, machine.Pin.PULL_UP)
left = machine.Pin(13, machine.Pin.IN, machine.Pin.PULL_UP)
right = machine.Pin(14, machine.Pin.IN, machine.Pin.PULL_UP)
select = machine.Pin(15, machine.Pin.IN, machine.Pin.PULL_UP)
ack_in = machine.Pin(22, machine.Pin.IN, machine.Pin.PULL_UP)

# set default screen
def screen():
    lcd.move_to(0, 0)
    lcd.putstr(" TD Display Tester")
    lcd.move_to(0, 2)
    lcd.putstr("  To start press:   ")
    lcd.move_to(0, 3)
    lcd.putstr("  1, 2, 3, 4 or 5  ")

screen()

#define characters
def ampersand():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()    

def A():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()
    
def B():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def C():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def D():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def E():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def F():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def G():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def H():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()   

def I():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def J():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def K():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def L():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def M():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def N():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def O():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def P():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start() 

def Q():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def R():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def S():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def T():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def U():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def V():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def W():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def X():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def Y():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def Z():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def left_sq_bracket():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def back_slash():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def right_sq_bracket():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def up_arrow():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def underscore():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def blank():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def exclamation():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def quotation():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def hash_():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def dollar():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def percent():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def ampersand():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def apostrophe():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def open_bracket():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()   

def close_bracket():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def asterisk():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def plus():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def comma():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def hyphen():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def full_stop():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def forward_slash():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def zero():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start() 

def one():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def two():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def three():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def four():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def five():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def six():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def seven():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def eight():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()    

def nine():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def colon():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def semi_colon():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def less_than():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def equal():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def greater_than():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def question():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def ack():
    utime.sleep_ms(4)
    while True:
        if ack_in.value()==0:
            return
            utime.sleep_ms(1)
    
#start pulse
def start():
    exts.value(0)
    utime.sleep_ms(2)
    exts.value(1)
    ack()
#    utime.sleep_ms(5)

#common delays
def delay():
    utime.sleep_ms(500)
    
def delay2():
    utime.sleep_ms(1000)

#test sequences
def test1():
    lcd.move_to(0, 2)
    lcd.putstr("      NUMBERS       ")
    lcd.move_to(0, 3)
    lcd.putstr("   [            ]   ")
    lcd.move_to(4, 3)
    zero()
    lcd.putstr("=")
    delay2()
    one()
    lcd.putstr("=")
    delay2()
    two()
    lcd.putstr("=")
    delay2()
    three()
    lcd.putstr("=")
    delay2()
    four()
    lcd.putstr("=")
    delay2()
    five()
    lcd.putstr("=")
    delay2()
    six()
    lcd.putstr("=")
    delay2()
    seven()
    lcd.putstr("=")
    delay2()
    eight()
    lcd.putstr("=")
    delay2()
    nine()
    lcd.putstr("=")
    delay2()
    asterisk()
    lcd.putstr("=")
    delay2()
    hyphen()
    lcd.putstr("=")
    delay2()
    blank()
    screen()

def test2():
    lcd.move_to(0, 2)
    lcd.putstr("      ALPHABET      ")
    lcd.move_to(0, 3)
    lcd.putstr("   [            ]   ")
    lcd.move_to(4, 3)
    A()
    lcd.putstr("=")
    delay2()
    B()
    delay2()
    C()
    lcd.putstr("=")
    delay2()
    D()
    delay2()
    E()
    delay2()
    F()
    lcd.putstr("=")
    delay2()
    G()
    delay2()
    H()
    delay2()
    I()
    lcd.putstr("=")
    delay2()
    J()
    delay2()
    K()
    delay2()
    L()
    lcd.putstr("=")
    delay2()
    M()
    delay2()
    N()
    lcd.putstr("=")
    delay2()
    O()
    delay2()
    P()
    lcd.putstr("=")
    delay2()
    Q()
    delay2()
    R()
    lcd.putstr("=")
    delay2()
    S()
    delay2()
    T()
    lcd.putstr("=")
    delay2()
    U()
    delay2()
    V()
    lcd.putstr("=")
    delay2()
    W()
    delay2()
    X()
    lcd.putstr("=")
    delay2()
    Y()
    delay2()
    Z()
    lcd.putstr("=")
    delay2()
    blank()
    screen()

def test3():
    lcd.move_to(0, 2)
    lcd.putstr("      SYMBOLS       ")
    lcd.move_to(0, 3)
    lcd.putstr("   [            ]   ")
    lcd.move_to(4, 3)
    left_sq_bracket()
    lcd.putstr("=")
    delay2()
    back_slash()
    delay2()
    right_sq_bracket()
    delay2()
    up_arrow()
    lcd.putstr("=")
    delay2()
    underscore()
    delay2()
    blank()
    delay2()
    exclamation()
    lcd.putstr("=")
    delay2()
    quotation()
    delay2()
    hash_()
    delay2()
    dollar()
    lcd.putstr("=")
    delay2()
    percent()
    delay2()
    ampersand()
    delay2()
    apostrophe()
    lcd.putstr("=")
    delay2()
    open_bracket()
    delay2()
    close_bracket()
    lcd.putstr("=")
    delay2()
    asterisk()
    delay2()
    plus()
    lcd.putstr("=")
    delay2()
    comma()
    delay2()
    hyphen()
    lcd.putstr("=")
    delay2()
    full_stop()
    delay2()
    forward_slash()
    lcd.putstr("=")
    delay2()
    colon()
    delay2()
    semi_colon()
    lcd.putstr("=")
    delay2()
    less_than()
    delay2()
    equal()
    lcd.putstr("=")
    delay2()
    greater_than()
    delay2()
    question()
    lcd.putstr("=")
    delay2()
    blank()
    screen()    

def test4():
    lcd.move_to(0, 2)
    lcd.putstr("Alpha Numeric Scroll")
    lcd.move_to(0, 3)
    lcd.putstr("   [            ]   ")
    lcd.move_to(4, 3)
    ampersand()
    lcd.putstr("=")
    delay2()
    A()
    delay2()
    B()
    delay2()
    C()
    delay2()
    lcd.putstr("=")
    D()
    delay2()
    E()
    delay2()
    F()
    delay2()
    G()
    lcd.putstr("=")
    delay2()
    H()
    delay2()
    I()
    delay2()
    J()
    delay2()
    K()
    lcd.putstr("=")
    delay2()
    L()
    delay2()
    M()
    delay2()
    N()
    delay2()
    O()
    lcd.putstr("=")
    delay2()
    P()
    delay2()
    Q()
    delay2()
    R()
    delay2()
    S()
    lcd.putstr("=")
    delay2()
    T()
    delay2()
    U()
    delay2()
    V()
    delay2()
    W()
    lcd.putstr("=")
    delay2()
    X()
    delay2()
    Y()
    delay2()
    Z()
    delay2()
    zero()
    lcd.putstr("=")
    delay2()
    one()
    delay2()
    two()
    delay2()
    three()
    delay2()
    four()
    lcd.putstr("=")
    delay2()
    five()
    delay2()
    six()
    delay2()
    seven()
    lcd.putstr("=")
    delay2()
    eight()
    delay2()
    nine()
    delay2()
    hyphen()
    lcd.putstr("=")
    delay2()
    asterisk()
    delay2()
    question()
    lcd.putstr("=")
    delay2()
    blank()
    screen()    

def test5():
    test1()
    test2()
    test3()
    test4()

#wait for key presses
while True:
    if up.value()==0:
        test1()
    if left.value()==0:
        test2()
    if select.value()==0:
        test3()
    if right.value()==0:
        test4()
    if down.value()==0:
        test5()
